#define IO_C

#include "IO.h"
#include "I2C1.h"
#include "UART.h"

void InitIO(void)
{
	//TRISB = 0
	TRISB = 0;		//Set RB15 as output
	LATB= 0;		//Set all values to 0
	
	
	//InitUARTx(int Baud, int RXpin, int TXpin)
	InitUART1(4800, 10, 5); // GPS 
	InitUART2(11500, 6, 7); //RF Communications

	InitADC();	
	
	InitI2C1();
}


void InitPORTB( int port, int dir, int val)
{
	if( dir == 1)
	{
		switch (port)
		{
			case 0 : 
				TRISBbits.TRISB0 = 1;
				break;	
			case 1 : 
				TRISBbits.TRISB1 = 1;
				break;
			case 2 : 
				TRISBbits.TRISB2 = 1;
				break;
			case 3 : 
				TRISBbits.TRISB3 = 1;
				break;
			case 4 : 
				TRISBbits.TRISB4 = 1;
				break;
			case 5 : 
				TRISBbits.TRISB5 = 1;
				break;
			case 6 : 
				TRISBbits.TRISB6 = 1;
				break;
			case 7 : 
				TRISBbits.TRISB7 = 1;
				break;
			case 8 : 
				TRISBbits.TRISB8 = 1;
				break;
			case 9 : 
				TRISBbits.TRISB9 = 1;
				break;
			case 10 : 
				TRISBbits.TRISB10 = 1;
				break;
			case 11 : 
				TRISBbits.TRISB11 = 1;
				break;
			case 12 : 
				TRISBbits.TRISB12 = 1;
				break;
			case 13 : 
				TRISBbits.TRISB13 = 1;
				break;
			case 14 : 
				TRISBbits.TRISB14 = 1;
				break;
			case 15 : 
				TRISBbits.TRISB15 = 1;
				break;
		}
	}
	else if (val == 0)
	{
		switch (port)
		{
			case 0 : 
				TRISBbits.TRISB0 = 0;
				break;	
			case 1 : 
				TRISBbits.TRISB1 = 0;
				break;
			case 2 : 
				TRISBbits.TRISB2 = 0;
				break;
			case 3 : 
				TRISBbits.TRISB3 = 0;
				break;
			case 4 : 
				TRISBbits.TRISB4 = 0;
				break;
			case 5 : 
				TRISBbits.TRISB5 = 0;
				break;
			case 6 : 
				TRISBbits.TRISB6 = 0;
				break;
			case 7 : 
				TRISBbits.TRISB7 = 0;
				break;
			case 8 : 
				TRISBbits.TRISB8 = 0;
				break;
			case 9 : 
				TRISBbits.TRISB9 = 0;
				break;
			case 10 : 
				TRISBbits.TRISB10 = 0;
				break;
			case 11 : 
				TRISBbits.TRISB11 = 0;
				break;
			case 12 : 
				TRISBbits.TRISB12 = 0;
				break;
			case 13 : 
				TRISBbits.TRISB13 = 0;
				break;
			case 14 : 
				TRISBbits.TRISB14 = 0;
				break;
			case 15 : 
				TRISBbits.TRISB15 = 0;
				break;
		}
		
		//writes the latch on the register
		if(val == 0)
		{
			switch (port)
			{
				case 0 : 
					LATBbits.LATB0 = 0;
					break;	
				case 1 : 
					LATBbits.LATB1 = 0;
					break;
				case 2 : 
					LATBbits.LATB2 = 0;
					break;
				case 3 : 
					LATBbits.LATB3 = 0;
					break;
				case 4 : 
					LATBbits.LATB4 = 0;
					break;
				case 5 : 
					LATBbits.LATB5 = 0;
					break;
				case 6 : 
					LATBbits.LATB6 = 0;
					break;
				case 7 : 
					LATBbits.LATB7 = 0;
					break;
				case 8 : 
					LATBbits.LATB8 = 0;
					break;
				case 9 : 
					LATBbits.LATB9 = 0;
					break;
				case 10 : 
					LATBbits.LATB10 = 0;
					break;
				case 11 : 
					LATBbits.LATB11 = 0;
					break;
				case 12 : 
					LATBbits.LATB12 = 0;
					break;
				case 13 : 
					LATBbits.LATB13 = 0;
					break;
				case 14 : 
					LATBbits.LATB14 = 0;
					break;
				case 15 : 
					LATBbits.LATB15 = 0;
					break;
			}
		}
		else if(val == 1)
		{
			switch (port)
			{
				case 0 : 
					LATBbits.LATB0 = 1;
					break;	
				case 1 : 
					LATBbits.LATB1 = 1;
					break;
				case 2 : 
					LATBbits.LATB2 = 1;
					break;
				case 3 : 
					LATBbits.LATB3 = 1;
					break;
				case 4 : 
					LATBbits.LATB4 = 1;
					break;
				case 5 : 
					LATBbits.LATB5 = 1;
					break;
				case 6 : 
					LATBbits.LATB6 = 1;
					break;
				case 7 : 
					LATBbits.LATB7 = 1;
					break;
				case 8 : 
					LATBbits.LATB8 = 1;
					break;
				case 9 : 
					LATBbits.LATB9 = 1;
					break;
				case 10 : 
					LATBbits.LATB10 = 1;
					break;
				case 11 : 
					LATBbits.LATB11 = 1;
					break;
				case 12 : 
					LATBbits.LATB12 = 1;
					break;
				case 13 : 
					LATBbits.LATB13 = 1;
					break;
				case 14 : 
					LATBbits.LATB14 = 1;
					break;
				case 15 : 
					LATBbits.LATB15 = 1;
					break;
			}
		}
	}
}

void mudaPORTB(void)
{
	if(LATBbits.LATB15)
	{
	LATBbits.LATB15 = 0;
	//LATBbits.LATB14 = 1;
	//LATBbits.LATB13 = 0;
	//LATBbits.LATB12 = 1;
	}
	else if(!LATBbits.LATB15)
	{
	LATBbits.LATB15 = 1;
	//LATBbits.LATB14 = 0;
	//LATBbits.LATB13 = 1;
	//LATBbits.LATB12 = 0;
	}
}

void on_PORTB(void)
{	
	LATBbits.LATB15 = 1;
	//LATBbits.LATB14 = 1;
	//LATBbits.LATB13 = 1;
	//LATBbits.LATB12 = 1;
}

void off_PORTB(void)
{
	LATBbits.LATB15 = 0;
	//LATBbits.LATB14 = 0;
	//LATBbits.LATB13 = 0;
	//LATBbits.LATB12 = 0;
}

