#ifndef AUX_FUNC_H
#define AUX_FUNC_H

#include "p24fj48ga002.h"
#include <math.h>
#include <string.h>
#include <stdlib.h>

//PROTOTYPES
void wait (int t2w);

int C2V (int ADCval);

int C2cm (int ADCval);

double Azimuth ( int ADCX, int ADCY);

void data_decoder (char *data_string);

int ReadChecksum(char *str);

int CalcChecksum(char* str);

typedef struct
{
	double lat;		///<latitude
	char NSi;		///<N=north or S=south
	double lon;		///<longitude
	char WEi;		///<W=west or E=east
	double date;		///< date ddmmyy
	double UTC;		///< UTC time (hhmmss.msc)
	char nav_w; 		///< A=data valid or V=data not valid
	double pos_fix;		///< 0-Fix not available or invalid;	1-GPS SPS Mode, fix valid;	2-Differential GPS, SPS Mode, fix valid; 3-5 - Not supported
	char have_fix;
	double speed;		///<Speed over ground, Knots
	double n_sat;		///<Satellites Used, range 0 to 12
	int sat1;		///<Satellites used
	int sat2;
	int sat3;
	int sat4;
	int sat5;
	int sat6;
	int sat7;
	int sat8;
	int sat9;
	int sat10;
	int sat11;
	int sat12;
	double PDOP;	///<Position Dilution of Precision
	double HDOP;	///<Horizontal Dilution of Precision
	double VDOP;	///<Vertical Dilution of Precision
	double alt;
	double softver;
	double bat_left;
	double bat_hour;
	int USB;
	double dim;	///< 1 - Fix not available; 2 - 2D (<3 SVs used); 3 - 3D (>3 SVs used)
	double mode;	///< A - 2D Automaticallowed to switch 2D/3D
}data_struct;



#endif

